#  see rtgf.tex, rtgf.pdf for explanation
import sys,os
from numpy import *
import numpy.linalg as la

Nb,Ne = map(int,sys.argv[1:3])
vc0 = float(sys.argv[3])

emax=1.0  # band width  E_b
de = emax/(Nb-1)
dt=0.25*pi  # time step 
Nt=256  # number of time steps
vc=vc0/Nb
ss=' %4i %4i %8.5f %7.4f %6.3f %4i' % (Nb,Ne,de,vc0,dt,Nt)
print 'Nb,Ne,de,vc,dt,Nt', ss

ham=array([[0.0]*Nb]*Nb )
for i1 in range(Nb) :
  ham[i1,i1] = i1*de
  for i2 in range(Nb) :
    ham[i1,i2] += vc
es,U = la.eigh(ham)    # U gives the orbital wave functions
e2=Ne*de
ev = es[Ne]
shift = (es[Ne]-Ne*de)/de
print 'fractional shift',shift
Egs = 0.0
for i in range(Ne+1):
  Egs += es[i]
print 'Egs', Egs
W0=array([[0.0]*(Ne+1)]*Nb)
for i in range(Ne) :
  W0[i,i] = 1.0
s1=0.0
for i in range(Ne,Nb) :
  W0[i,Ne] = 1.0
  s1 += W0[i,Ne]
Wv0=dot(transpose(U),W0)
Wvt=array([[0.0j]*(Ne+1)]*Nb )
gt=array([0.0j]*Nt)
G = dot(transpose(Wv0),Wv0)    #e*de
gt[0]=la.det(G)
T=dt*Nt
f1 = open('gt.dat','w')
for it in range(0,Nt):
 t=dt*it
 for i1 in range(Nb) :
   Wvt[i1,:] = exp(-1.0j *es[i1]*t)*Wv0[i1,:]
 olpm=dot(transpose(Wv0),Wvt)
 gt[it] =la.det(olpm)*exp(1.0j*Egs*t)
 if it==0: gt[it] = gt[it]*0.5             #trapezoidal weight
 ss = ' %6.4f %8.5f %8.5f\n' % (t,gt[it].real,gt[it].imag)
 f1.write(ss)
f1.close()
# Fourier transform below
gt = conjugate(gt)
Nres=8
fflag = 1
f2 = open('gcw.dat','w')
if fflag == 1:
  Ntp = Nt*Nres
  gtf=array([0.0j]*Ntp)
  for it in range(1,Nt):
    x = dt*it/T 
    filter = 1.0 -3.0*x**2+2.0*x**3
    gtf[it] = gt[it]*filter
 
  gw_raw= fft.fft(gtf)
  gw_raw=gw_raw*dt
  gw= fft.fftshift(gw_raw)
  for io in range(Ntp) :
    w= (io-Ntp/2.)*2*pi/(dt*Ntp)
    wp = -w-5.0
    if w >= 0.0:
      ss=' %8.4f  %8.5f  %8.5f\n ' % (w,real(gw[io]),imag(gw[io]))
      f2.write(ss)
f1.close()
f2.close()
plot = 1
if plot == 1 :   # plot flag
  ss='''
set term postscript eps enhanced "Times-Roman" 28
set output "gcw.eps"
set nokey
set size 1.0,1.0
set xlabel " {/Symbol w}   "
set ylabel "  g_c({/Symbol w})"
#set logscale x
#set logscale y
plot [-0.1:1.0] 'gcw.dat' using 1:2 w p,  'zero.dat' u 1:2 w l'''
  f2=open('gcw.gnu','w')
  f2.write(ss)
  f2.close()
  os.system('gnuplot gcw.gnu')
  os.system('open gcw.eps')            
